﻿#   calcul d'une incertitude de type B: Exemple du pendule

import matplotlib.pyplot as plt
from decimal import *

#--------------------Partie à  compléter ------------------------------

g= 0                    # Valeur expérimentale de g en N/kg

T= 0                    # Valeur mesurée de T en ms
UT_liste=[0,0]              #Valeurs des différentes causes d'incertitude sur T en ms et séparées par des ,

L= 0                    # Valeur mesurée de L en mm
UL_liste=[0,0]              #Valeurs des différentes causes d'incertitude sur L en mm et séparées par des ,


#-----------------------Programme principal---------------------------

UT_liste=[(elmt)**2/3 for elmt in UT_liste]
UL_liste=[(elmt)**2/3 for elmt in UL_liste]

UT=sum(UT_liste)**0.5                   #Incertitude-type sur T
UT=float(Decimal(UT).quantize(Decimal('.01'), rounding=ROUND_UP))   #arrondi par le haut avec 2 décimales

UL=sum(UL_liste)**0.5                   #Incertitude-type sur L
UL=float(Decimal(UL).quantize(Decimal('.01'), rounding=ROUND_UP))   #arrondi par le haut avec 2 décimales

Ug=g*((UL/L)**2 + (2*UT/T)**2)**0.5     #Incertitude-type sur g
Ug=float(Decimal(Ug).quantize(Decimal('.01'), rounding=ROUND_UP))     # Arrondi par le haut avec 2 décimales


#Ecriture des résultats
print('L incertitude-type  sur T est : U(T)=',UT,'ms')
print('L incertitude-type  sur L est : U(L)=',UL,'mm')
print('----------------------------------------------')
print('L incertitude-type  sur g est : U(g)=',Ug,'N/kg')


#Répartition des incertitudes-type sur la variance
pourcentUL=(g*UL/L)**2/Ug**2*100
pourcentUT=(2*g*UT/T)**2/Ug**2*100


# Représentation graphique
name = ['Incertitude sur L','Incertitude sur T' ]
data = [pourcentUL, pourcentUT]
plt.title('Contributions à la variance')
plt.pie(data, labels=name,autopct='%1.0f%%', startangle=45)
plt.axis('equal')
plt.show()
